<i18n>
{
  "fr": {
    "title-1": "Modifier un bâtiment",
    "title-2": "Ajouter un bâtiment",
    "title-3": "Visualiser un bâtiment",
    "info-1": "Indiquez la surface utile brute (SUB) du bâtiment et la part occupée par votre laboratoire. Soit vous avez l’information précise pour cette part et vous la renseignez, soit vous l’estimez le mieux possible sur la base de vos observations.",
    "info-2": "Saisissez la consommation du bâtiment en chauffage, électricité et fluides frigorigènes. <br /> Par défaut la saisie des données est mensuelle. Si vous avez seulement une donnée annuelle, décochez la case « Consommations mensuelles disponibles ».",
    "info-3": "Pour les consommations de fluides frigorigènes, il est indispensable de connaître le fluide frigorigène utilisé car le pouvoir de réchauffement global de ces gaz est très différent d’un gaz à l’autre.",
    "info-4": "Si vous avez les factures d’entretien des systèmes de réfrigération / climatisation, vous disposez a priori du gaz concerné et des quantités de gaz injectées dans les systèmes pour compenser les fuites.",
    "info-5": "La consommation du chauffage electrique est incluse dans la consommation d'electricité.",
    "check-1": "Le bâtiment produit et autoconsomme de l’électricité photovoltaïque.",
    "check-2": "Le laboratoire est propriétaire de cette installation de chauffage.",
    "tooltip-1": "Si l’électricité n’est pas autoconsommée mais revendue sur le réseau, ne pas cocher la case.",
    "tooltip-2": "Si le batiment possède plusieurs systèmes de chauffage, rajoutez des onglets chauffage en cliquant ici",
    "tooltip-3": "Supprimer le système de chauffage",
    "field-1": "Type de chauffage",
    "field-2": "Réseau de chaleur",
    "field-3": "Consommations mensuelles disponibles en",
    "field-4": "Consommation totale en",
    "field-5": "Autoconsommation totale annuelle en kWh",
    "field-6": "Consommation en kg",
    "field-7": "Site",
    "field-8": "Surface utile brute (m2)",
    "field-9": "Part de la SUB (%)",
    "error-1": "Identifiant déjà utilisé.",
    "error-2": "Réseau de chaleur non valide.",
    "refrigerant": "Fluide frigorigène",
    "no-refrigerant": "Aucun Fluide frigorigène",
    "more": "Plus",
    "less": "Moins"
  },
  "en": {
    "title-1": "Update a building",
    "title-2": "Add a building",
    "title-3": "Visualize building data",
    "info-1": "Enter the gross useful floor area of the building and the share occupied by the laboratory. Either you have the precise share and you enter it, or you assess it as best as you can based on your own observation.",
    "info-2": "Enter the heating, electricity and refrigerant gases consumptions of the building. <br /> By default the data entry is per month. If you only have data per year, uncheck the box « Monthly consumption available ».",
    "info-3": "For refrigerant gases, you must know which refrigerant gas is used, as their global warming potential differs widely",
    "info-4": "If you have the bills relating to the maintenance of the refrigeration / air conditioning systems, you may find therein the gas considered and the quantity injected into the systems to offset leakages.  ",
    "info-5": "Consumption of this electric heating is included in the electricity consuption",
    "check-1": "The photovoltaic electricity generated by the building is self-consumed.",
    "check-2": "The laboratory is the owner of this heating system.",
    "tooltip-1": "If the electricity is not self-consumed but sold to the grid, do not check the box.",
    "tooltip-2": "If the building has several heating systems, add heating tabs by clicking here",
    "tooltip-3": "Remove heating system",
    "field-1": "Heating type",
    "field-2": "District heating",
    "field-3": "Monthly consumption available in",
    "field-4": "Total consumption in",
    "field-5": "Total yearly self-consumption in kWh",
    "field-6": "Consumption in kg",
    "field-7": "Site",
    "field-8": "Gross useful floor area (m2)",
    "field-9": "Share of the gross useful area (%)",
    "error-1": "Name already used",
    "error-2": "Unvalid district heating.",
    "refrigerant": "Refrigerant",
    "no-refrigerant": "No refrigerant",
    "more": "More",
    "less": "Less"
  }
}
</i18n>

<template>
  <b-modal
    :can-cancel="['escape', 'x', 'outside']"
    :active="displayModal"
    @close="closeForm"
    has-modal-card
  >
    <div class="modal-card" style="width: 1000px; height: auto">
      <form @submit.prevent="validateBeforeSubmit">
        <header class="modal-card-head">
          <p class="modal-card-title">{{ modalTitle }}</p>
        </header>
        <section class="modal-card-body">
          <b-notification :closable="false">
            {{ $t('info-1') }}
            <br />
            <br />
            <div class="columns">
              <div class="column">
                <b-field
                  v-if="allBuildings.length === 0"
                  :label="$t('id')"
                  :type="{'is-danger': errors.has('id')}"
                  :message="errors.first('id')"
                >
                  <b-input
                    name="id"
                    icon="building"
                    :disabled="submitted"
                    v-validate="'required|uniqueID'"
                    maxlength="50"
                    v-model="cbuilding.name"
                  ></b-input>
                </b-field>
                <b-field
                  v-else
                  :label="$t('id')"
                  :type="{'is-danger': errors.has('id')}"
                  :message="errors.first('id')"
                >
                  <b-autocomplete
                    name="id"
                    icon="building"
                    v-model="cbuilding.name"
                    :disabled="submitted"
                    :open-on-focus="true"
                    :data="allBuildings"
                    v-validate="'required|uniqueID'"
                    field="name"
                    @typing="reset"
                    @select="option => selectBuilding(option)">
                  </b-autocomplete>
                </b-field>
              </div>
              <div class="column" v-show="sites.length > 0">
                <b-field :label="$t('field-7')">
                  <b-select
                    expanded
                    :disabled="submitted"
                    v-model="cbuilding.site"
                  >
                    <option :value="mainSite">{{ mainSite }}</option>
                    <option
                      v-for="(csite,index) in sites"
                      :value="csite.name"
                      :key="index"
                    >
                      {{ csite.name }}
                    </option>
                  </b-select>
                </b-field>
              </div>
              <div class="column">
                <b-field
                  :label="$t('field-8')"
                  :type="{'is-danger': errors.has('area')}"
                  :message="errors.first('area')">
                  <b-input
                    name="area"
                    :disabled="submitted"
                    v-validate="'required|numeric|min_value:1'"
                    v-model="cbuilding.area"
                  ></b-input>
                </b-field>
              </div>
              <div class="column">
                <b-field
                  :label="$t('field-9')"
                  :type="{'is-danger': errors.has('share')}"
                  :message="errors.first('share')">
                  <b-input
                    name="share"
                    :disabled="submitted"
                    v-validate="'required|decimal:2|max_value:100|min_value:0.01'"
                    v-model="cbuilding.share"
                  ></b-input>
                </b-field>
              </div>
            </div>
          </b-notification>
          <b-notification :closable="false" v-html="$t('info-2')" />
          <m-tabs v-model="activeTab" class="block" style="margin:auto !important" >
            <m-tab-item icon="plug" :label="$t('electricity')">
              <b-notification :closable="false">
                <b-checkbox
                  :disabled="submitted"
                  v-model="cbuilding.selfProduction"
                >
                  {{ $t('check-1') }}
                  <b-tooltip
                    multilined
                    :label="$t('tooltip-1')"
                    type="is-dark"
                  >
                    <b-icon icon="info-circle" />
                  </b-tooltip>
                </b-checkbox>
                <br v-if="cbuilding.selfProduction"/>
                <br v-if="cbuilding.selfProduction"/>
                <b-field
                  v-show="cbuilding.selfProduction"
                  :label="$t('field-5')"
                  :type="{'is-danger': errors.has('selfConsumption')}"
                  :message="errors.first('selfConsumption')"
                  style="margin-bottom:25px !important">
                  <b-input
                    :disabled="submitted"
                    name="selfConsumption"
                    v-validate="'required|numeric'"
                    v-model="cbuilding.selfConsumption"
                  ></b-input>
                </b-field>
              </b-notification>
              <b-notification :closable="false">
                <consumption-form :disabled="submitted" v-model="cbuilding.electricity">
                  <template v-slot:monthly>
                    {{ $t('field-3') }} {{ $t('kwh') }}
                  </template>
                  <template v-slot:total>
                    {{ $t('field-4') }} {{ $t('kwh') }}
                  </template>
                </consumption-form>
              </b-notification>
            </m-tab-item>
            <m-tab-item icon="snowflake-o" :label="$t('refrigerants')">
              <b-notification :closable="false">
                {{ $t('info-3') }}
                <b-collapse :open="false" position="is-bottom" aria-id="contentIdForA11y1">
                  <a class="link" slot="trigger" slot-scope="props" aria-controls="contentIdForA11y1">
                    <b-icon :icon="!props.open ? 'caret-down' : 'caret-up'"></b-icon>
                    {{ !props.open ? $t('more') : $t('less') }}
                  </a>
                  {{ $t('info-4') }}
                </b-collapse>
              </b-notification>
              <table
                class="table is-narrow is-striped is-hoverable has-mobile-cards"
                style="width:100%"
              >
                <thead>
                  <tr>
                    <th>
                      <div class="th-wrap">
                        {{ $t('refrigerant') }}
                      </div>
                    </th>
                    <th>
                      <div class="th-wrap">
                        {{ $t('field-6') }}
                      </div>
                    </th>
                    <th style="width: 60px;"></th>
                  </tr>
                </thead>
                <tbody>
                  <tr class="is-empty" v-show="cbuilding.refrigerants.length===0">
                    <td colspan="3">
                      <section class="section">
                        <div class="content has-text-grey has-text-centered">
                          <p>
                            <i class="sui sui-ban" style="font-size: 64px;"></i>
                          </p>
                          <p>
                            {{ $t('no-refrigerant') }}
                          </p>
                        </div>
                      </section>
                    </td>
                  </tr>
                  <tr
                    v-for="refrigerant in cbuilding.refrigerants"
                    :key="refrigerant.id"
                    draggable="false"
                  >
                    <td class="has-text-center">
                      {{ getRefrigerantDescription(refrigerant.name) }}
                    </td>
                    <td class="has-text-center">
                      {{ refrigerant.total }}
                    </td>
                    <td>
                      <b-button @click="deleteRefrigerant(refrigerant)">
                        <i class="sui sui-trash" style="font-size: 16px;"></i>
                      </b-button>
                    </td>
                  </tr>
                </tbody>
                <tfoot>
                  <tr>
                    <th>
                      <b-select
                        expanded
                        :disabled="submitted"
                        v-model="crefrigerant.name"
                      >
                        <option
                          :value="refrigerant"
                          v-for="(refrigerant,index) in refrigerants"
                          :key="index"
                        >
                          {{ getRefrigerantDescription(refrigerant) }}
                        </option>
                      </b-select>
                    </th>
                    <th>
                      <b-field
                          :type="{'is-danger': errors.has('crefrigerantConsumption')}"
                          :message="errors.first('crefrigerantConsumption')">
                        <b-input
                          name="crefrigerantConsumption"
                          v-model="crefrigerant.total"
                          :disabled="submitted"
                          v-validate="'required|decimal'"
                        ></b-input>
                      </b-field>
                    </th>
                    <th style="width: 60px;">
                      <b-button
                        :disabled="isNaN(crefrigerant.total) || crefrigerant.total==='' || submitted"
                        @click="addRefrigerant"
                      >
                        <i class="sui sui-plus" style="font-size: 16px;"></i>
                        {{ $t('add') }}
                      </b-button>
                    </th>
                  </tr>
                </tfoot>
              </table>
            </m-tab-item>
            <m-tab-item v-for="(heating, index) in cbuilding.heatings" :key="index">
              <template v-if="index > 0" slot="headerClosable">
                <span class="icon"><i class="sui sui-thermometer-full"></i></span>
                <span class="heating-header"> {{ $t('heating') }} {{ index + 1 }} </span>
                <b-tooltip
                  multilined
                  :label="$t('tooltip-3')"
                  type="is-dark"
                >
                  <b-button class="is-white is-small" style="margin-left: 5px" @click="deleteHeatingSystem(heating)">
                    <b-icon icon="close" size="is-small"></b-icon>
                  </b-button>
                </b-tooltip>
              </template>
              <template v-else slot="header">
                <span class="icon"><i class="sui sui-thermometer-full"></i></span>
                <span class="heating-header"> {{ $t('heating') }} </span>
              </template>
              <b-notification :closable="false">
                <div class="columns">
                  <div class="column is-one-third">
                    <b-field
                      :label="$t('field-1')"
                      :type="{'is-danger': errors.has('heating')}"
                      :message="errors.first('heating')"
                    >
                      <b-select
                        expanded
                        name="heating"
                        :disabled="submitted"
                        :placeholder="$t('field-1')"
                        v-model="cbuilding.heatings[index].type"
                        @input="updateNetwork(index)"
                      >
                        <option
                          :selected="index===0"
                          :value="heating"
                          v-for="(heating,index) in heatings"
                          :key="index"
                        >
                          {{ $t(heating) }}
                        </option>
                      </b-select>
                    </b-field>
                  </div>
                  <div class="column">
                    <b-field
                      :label="$t('field-2')"
                      :type="{'is-danger': errors.has('network')}"
                      :message="errors.first('network')"
                    >
                      <b-autocomplete
                        expanded
                        name="network"
                        v-validate="{ required: cbuilding.heatings[index].type === URBAN_NETWORK, isUrbanNetwork: true }"
                        :placeholder="$t('field-2')"
                        :disabled="cbuilding.heatings[index].type !== URBAN_NETWORK || submitted"
                        v-model="urbanNetwork[index]"
                        :open-on-focus="true"
                        :data="filteredUrbanNetwork(index)"
                        field="description_FR"
                        @select="option => cbuilding.heatings[index].urbanNetwork = option.network"
                        :clearable="true"
                      />
                    </b-field>
                  </div>
                </div>
              </b-notification>
              <b-notification
                v-if="cbuilding.heatings[index].type === 'electric'"
                :closable="false"
                v-html="$t('info-5')"
              />
              <b-notification :closable="false" v-show="cbuilding.heatings[index].type !== 'electric'">
                <b-checkbox
                  :disabled="submitted"
                  v-model="cbuilding.heatings[index].isOwnedByLab"
                >
                  {{ $t('check-2') }}
                </b-checkbox>
              </b-notification>
              <b-notification :closable="false" v-show="cbuilding.heatings[index].type !== 'electric'">
                <consumption-form
                  :disabled="submitted"
                  v-model="cbuilding.heatings[index]"
                >
                  <template v-slot:monthly>
                    {{ $t('field-3') }} {{ $t(heatingUnit(cbuilding.heatings[index])) }}
                  </template>
                  <template v-slot:total>
                    {{ $t('field-4') }} {{ $t(heatingUnit(cbuilding.heatings[index])) }}
                  </template>
                </consumption-form>
              </b-notification>
            </m-tab-item>
            <template slot="addTab">
                <b-tooltip
                    multilined
                    :label="$t('tooltip-2')"
                    type="is-dark"
                >
                  <button
                    class="button is-white is-small add"
                    type="button"
                    @click="addHeatingSystem"
                  >
                    <i class="sui sui-plus" style="font-size: 18px;"></i>
                  </button>
                </b-tooltip>
            </template>
          </m-tabs>

          <hr />
          <nav class="level">
            <div class="level-left"></div>
            <div class="buttons level-right">
              <b-button
                class="button"
                @click="closeForm()"
                icon-left="close"
              >
                {{ $t('cancel') }}
              </b-button>
              <button
                v-show="modeCreation"
                :disabled="submitted"
                type="submit"
                class="button is-primary"
              >
                <span class="icon is-small"><i class="sui sui-plus"></i></span>
                <span> {{ $t('add') }} </span>
              </button>
              <button
                :disabled="submitted"
                v-show="!modeCreation"
                type="submit"
                class="button is-primary"
              >
                <span class="icon is-small"><i class="sui sui-refresh"></i></span>
                <span> {{ $t('update') }} </span>
              </button>
            </div>
          </nav>
        </section>
      </form>
    </div>
  </b-modal>
</template>

<script>
import Building from '@/models/carbon/Building.js'
import { mapGetters } from 'vuex'

const DEFAULT_REFRIGERANT = 'nf3'

export default {
  name: 'BuildingModal',
  props: {
    displayModal: {
      type: Boolean,
      default: false
    },
    building: {
      type: Object,
      default: function () {
        return {}
      }
    },
    buildings: {
      type: Array,
      default: function () {
        return []
      }
    },
    modeCreation: {
      type: Boolean,
      default: false
    }
  },
  components: {
    'consumption-form': () => import('@/components/carbon/forms/ConsumptionForm.vue'),
    'm-tabs': () => import('@/components/tabs_custom//Tabs.vue'),
    'm-tab-item': () => import('@/components/tabs_custom//TabItem.vue')
  },
  $_veeValidate: {
    validator: 'new'
  },
  data () {
    return {
      URBAN_NETWORK: Building.urbanNetwork,
      cbuilding: Object.assign({}, this.building),
      crefrigerant: {
        id: null,
        name: DEFAULT_REFRIGERANT,
        total: 0
      },
      urbanNetwork: [''],
      activeTab: 0
    }
  },
  computed: {
    ...mapGetters('authentication', ['isAuthenticated']),
    refrigerants: function () {
      return Building.getRefrigerants()
    },
    urbanNetworks: function () {
      return Building.getUrbanNetworks()
    },
    heatings: function () {
      return Building.getHeatings()
    },
    submitted: function () {
      return this.$store.getters['ghgi/item']['buildingsSubmitted']
    },
    allBuildings: function () {
      let usedName = this.buildings.map(obj => obj.name)
      return this.$store.getters['admin/allBuildings'].filter(obj => !(usedName.includes(obj.name)))
    },
    laboratory: function () {
      return this.$store.getters['api/laboratory']
    },
    sites: function () {
      if ('sites' in this.laboratory) {
        return this.laboratory.sites
      } else {
        return []
      }
    },
    mainSite: function () {
      if ('mainSite' in this.laboratory) {
        return this.laboratory.mainSite
      } else {
        return ''
      }
    },
    modalTitle: function () {
      let title = this.$t('title-1')
      if (this.modeCreation) {
        title = this.$t('title-2')
      } else if (this.submitted) {
        title = this.$t('title-3')
      }
      return title
    }
  },
  methods: {
    heatingUnit (heatingSystem) {
      let unit = 'kwh.lhv'
      if (heatingSystem.type !== null && heatingSystem.type !== this.URBAN_NETWORK && heatingSystem.type !== 'electric') {
        unit = Building.getHeatingUnit(heatingSystem.type)
      }
      return unit
    },
    validateBeforeSubmit () {
      this.$validator.validateAll().then((result) => {
        if (result) {
          if (this.modeCreation) {
            this.$emit('add', this.cbuilding)
          } else {
            this.$emit(
              'update',
              {
                'from': this.building,
                'to': this.cbuilding
              }
            )
          }
        }
      })
    },
    updateNetwork (i) {
      if (this.cbuilding.heatings[i].type !== this.URBAN_NETWORK) {
        this.cbuilding.heatings[i].urbanNetwork = null
        this.urbanNetwork[i] = ''
      }
    },
    filteredUrbanNetwork (i) {
      return this.urbanNetworks.filter(option => {
        return (
          option.description_FR
            .toString()
            .toLowerCase()
            .indexOf(this.urbanNetwork[i].toLowerCase()) >= 0
        )
      })
    },
    getRefrigerantDescription (type) {
      return Building.getDescription('refrigerants', type)
    },
    selectBuilding (building) {
      this.cbuilding.id = building.id
      this.cbuilding.name = building.name
      this.cbuilding.site = building.site
      this.cbuilding.selfProduction = building.selfProduction
      this.cbuilding.area = building.area
      this.cbuilding.share = building.share
    },
    reset () {
      this.cbuilding.id = null
      this.cbuilding.name = ''
      this.cbuilding.site = this.mainSite
      this.cbuilding.selfProduction = false
      this.cbuilding.area = 0
      this.cbuilding.share = 100
    },
    closeForm: function () {
      this.$emit('close')
    },
    addRefrigerant: function () {
      this.cbuilding.refrigerants.push({
        'id': this.crefrigerant.id,
        'name': this.crefrigerant.name,
        'total': this.crefrigerant.total
      })
      this.crefrigerant.name = DEFAULT_REFRIGERANT
      this.crefrigerant.total = 0
    },
    deleteRefrigerant: function (gas) {
      let index = null
      if (gas.id === null) {
        index = this.cbuilding.refrigerants.findIndex(obj => obj.name === gas.name)
      } else {
        index = this.cbuilding.refrigerants.findIndex(obj => obj.id === gas.id)
      }
      this.cbuilding.refrigerants.splice(index, 1)
    },
    addHeatingSystem: function () {
      this.cbuilding.heatings.push({
        id: null,
        type: null,
        urbanNetwork: null,
        january: 0,
        february: 0,
        march: 0,
        april: 0,
        may: 0,
        june: 0,
        july: 0,
        august: 0,
        septembre: 0,
        octobre: 0,
        novembre: 0,
        decembre: 0,
        total: 0,
        isMonthly: true,
        isOwnedByLab: false
      })
      this.urbanNetwork.push('')
      // this.activeTab = this.cbuilding.heatings.length +1
      setTimeout(() => { this.activeTab = this.cbuilding.heatings.length + 1 }, 200)
    },
    deleteHeatingSystem: function (heating) {
      let index = null
      if (heating.id === null) {
        index = this.cbuilding.heatings.findIndex(obj => obj.type === heating.type)
      } else {
        index = this.cbuilding.heatings.findIndex(obj => obj.id === heating.id)
      }
      this.cbuilding.heatings.splice(index, 1)
      this.activeTab = 0
    }
  },
  created () {
    let self = this
    this.$validator.extend('uniqueID', {
      getMessage: field => self.$t('error-1'),
      validate: (value) => {
        if (!this.modeCreation) {
          if (value === this.cbuilding.name) {
            return true
          } else {
            return this.buildings.filter(obj => obj.name === value).length === 0
          }
        } else {
          return this.buildings.filter(obj => obj.name === value).length === 0
        }
      }
    })
    this.$validator.extend('isUrbanNetwork', {
      getMessage: field => self.$t('error-2'),
      validate: (value) => {
        return this.urbanNetworks.map(obj => obj.description_FR).includes(value)
      }
    })
    if (!this.modeCreation) {
      this.building.heatings.forEach(function (heating, i) {
        self.urbanNetwork[i] = self.urbanNetworks.filter(obj => obj.network === heating.urbanNetwork)
        if (self.urbanNetwork[i].length > 0) {
          self.urbanNetwork[i] = self.urbanNetwork[i][0].description_FR
        } else {
          self.urbanNetwork[i] = ''
        }
      })
    }
  },
  mounted () {
    // let self = this
    // this.building.heatings.forEach(function (heating, i) {
    //   self.urbanNetwork[i] = self.urbanNetworks.filter(obj => obj.network === heating.urbanNetwork)
    //   if (self.urbanNetwork[i].length > 0) {
    //     self.urbanNetwork[i] = self.urbanNetwork[i][0].description_FR
    //   } else {
    //     self.urbanNetwork[i] = ''
    //   }
    // })
    //
    // New version
    //
    // this.urbanNetwork = this.urbanNetworks.filter(obj => obj.network === this.building.urbanNetwork)
    // if (this.urbanNetwork.length > 0) {
    //   this.urbanNetwork = this.urbanNetwork[0].description_FR
    // } else {
    //   this.urbanNetwork = ''
    // }
    if (this.isAuthenticated) {
      const loadingComponent = this.$buefy.loading.open({
        container: null
      })
      this.$store.dispatch('admin/getAllBuildings')
        .then(data => {
          loadingComponent.close()
        })
    }
  }
}
</script>
<style>
  .add-button {
    margin-left: 10px;
    padding-bottom: 3px;
  }
</style>
